/*****************************************************************************/
//    CoreHashTable.h
/*****************************************************************************/

#ifndef _CoreHashTable_H_
#define _CoreHashTable_H_

#include "GenericHashTable.h"

/*****************************************************************************/
/*
    This file defines a class for hash tables.  The only data type that can
    be stored in the table is void *.  NULL pointers may not be stored in
    the table.  A hash value must be provided with the datum.  Also a
    function that can compare two void *'s must be provided.
*/
/*****************************************************************************/

class CoreHashTable: public corGenericHashTable {
    corHashEntry *table;
public:
    CoreHashTable(EqualsFn eqf1, int initsize1=128, double incr_ratio1 = -1.0,
        double max_occupancy1 = -1.0);

    inline void rehash_if_needed() {
        if (cur_size > limit) rehash_bigger();
    }

    virtual void *insert(void *entry, int hashval, int& to_delete);
    void *insert(void *entry, int hashval) {
       int to_delete = 0;
       return insert(entry, hashval, to_delete); 
    }
    virtual void *lookup(void *entry, int hashval);
    void rehash_bigger();
};

/*****************************************************************************/

#endif _CoreHashTable_H_

