//**********************************
// GraceJoin.h
//
// Ravi Murthy
//**********************************

#ifdef    WITH_PERSISTENCE
#ifndef _GraceJoin_H_
#define _GraceJoin_H_

#include "Plan.h"
#include "JoinAttrs.h"
#include "HashJoin.h"
#include "Partition.h"

//*****************************************************

// This class performs Grace Join on two external relations.

class Cor_GraceJoin : public Cor_ExtJoin {
  public:
    Cor_GraceJoin(Cor_TupleIterator* left, Cor_TupleIterator *right);
    virtual ~Cor_GraceJoin();

    virtual Cor_Tuple *get_next_tuple(Cor_TupleIterator& it);

  private:
    Cor_JoinAttrs *joinattrs;
    Cor_Partition *outer_part;
    Cor_Partition *inner_part;

    int new_part_start;    // Should we start looking at a new partition?
    int next_part_num;     // What is the partition number?
    Cor_TupleIterator *innerpart_iter; // iterator over inner partition
    Cor_TupleIterator *outerpart_iter; // iterator over outer partition
    Cor_HashJoin *curr_hashjoin;  // Current hash join object
};

// *************************************************************************
#endif
#endif // WITH_PERSISTENCE
