// *************************************************************************
//    HashIndexSet.h
// *************************************************************************

#ifndef _HashIndexSet_H_
#define _HashIndexSet_H_

#include "GenericIndexSet.h"
#include "HashIndex.h"

// *************************************************************************

class Cor_HashIndexSet : public Cor_GenericIndexSet {

  protected:
    int find_exact( Cor_HashIndex *index);

  public: 
    Cor_HashIndexSet(Cor_StorageRelation *rel) : Cor_GenericIndexSet(rel) {}

      // Delete this tuple from all indices
    int delete_tuple(Cor_Tuple *tuple);

    virtual Cor_GenericIndex *find_index( Cor_TupleIterator& iterator) {
        return find_index(iterator.arg_list, iterator.bindenv,
            iterator.indexnump);
    }

    virtual Cor_GenericIndex *find_index(Cor_Tuple *tuple,
                                            int *tryindexp = NULL){
        return find_index(*(tuple->_args), NULL, tryindexp);
    }

    virtual Cor_GenericIndex *find_index(Cor_ArgList&,Cor_BindEnv*,
        int *tryindexp = NULL);
    int insert_index(Cor_GenericIndex*);
    void fill_index(Cor_GenericIndex*);

    virtual int add_all_tuples(Cor_StorageRelation *reln,
        int marks_into_account = 0, int check_dupl = 0);
    virtual int add_all_goals(Cor_StorageRelation *_reln, Cor_Context *_context,
        Cor_StorageRelation *owner_rel);
    int move_all_entries(Cor_StorageRelation *reln);
};

// *************************************************************************

#endif _HashIndexSet_H_
