//**********************************************
//   JoinAttrs.h
//
// Ravi Murthy
//**********************************************

#ifdef    WITH_PERSISTENCE
#ifndef _JoinAttrs_H_
#define _JoinAttrs_H_

#include "Plan.h"

// *************************************************************************
// This class maintains the information regarding the attributes to be 
// joined in the two relations. This object is kept for each join.

class Cor_JoinAttrs {
  public:
    Cor_JoinAttrs(int *attrlist, int num);

    int hash_value(Cor_BindEnv *env);
    
    // This function checks if the join attributes of the two envs are
    // identical, and if so, superimposes bindings in env2 on env1. 
    // Thus, if it returns TRUE, env1 will be the result of the JOIN
    // of the two tuples.
    int compare(Cor_BindEnv* env1, Cor_BindEnv *env2,
        Cor_ArgList& args1, Cor_ArgList& args2);

  private:
    int *attrs;
    int num_attrs;
};

// *************************************************************************
#endif
#endif // WITH_PERSISTENCE
