// RdbCompilableDML inlines


inline RdbCompilableDML::~RdbCompilableDML()
{
    database.DeregisterCompilableDML( *this );
}

inline void RdbCompilableDML::Invalidate()
{
    ready = FALSE;
}


inline Boolean RdbCompilableDML::IsReady() const
{
    return ready; 
}


inline int RdbCompilableDML::Prepare()
{
    database.SetFocus();
    ErrorCode rc = database.VPrepare(id, statement);
    if( rc == NO_ERROR )
      ready = TRUE;
    return rc;
}

inline RdbDatabase& RdbCompilableDML::Database() const
{
    return database; 
}


inline String RdbCompilableDML::DatabaseName() const
{
    return database.DatabaseName(); 
}


inline String RdbCompilableDML::SystemName() const
{
    return database.SystemName(); 
}
