#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include "CoralIncludes.h"


static void _CORAL_dummytemp__13(); 
static void temp__12();

static void temp__inits();
static void temp__deletes();
static char __CORAL_BUILTIN_FAIL = 0;

#line 1 "Coral_Utils.S"
// This may look like C code, but it is really -*- C++ -*-

//**************************************************************************
// Coral_Utils.S - Utilities for Coral Tkx/Tclx shell
// 
//**************************************************************************

#include <stdio.h>
extern  "C" {
#  include <tcl.h>
} 

#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "Coral.h"
#include "Coral_Utils.h"
#include <new.h>
#include <assert.h>
#include <ctype.h>
#include <time.h>
#include <sys/param.h>
#include <sys/types.h>
#include "Interface.h"

#ifndef    TRUE
#    define    TRUE    (1)
#    define    FALSE   (0)
#endif

/*  #include <sys/select.h>  */

extern int errno;

#include "CoralInit.h"
#include "Globals.h"
#include "ParseStack.h"
#include "CoralError.h"
#include "Util.h"
#include "BuiltinUtil.h"
#include "Database.h"


/**********************************************************************
 * Inputs: A relation name and a predicate
 * Outputs: The arity of that relation
 * Comments: Returns 0 if arity cannot be found.
 **********************************************************************/

int Arity(char *relname, char *pred)
{
    Cor_Relation* rel = find_relation("arity",3);

    if (!rel)
        return(0);

    Cor_Tuple tup(make_arglist_d(3,make_arg(relname),
                make_arg(pred), make_var("XX",0)));

    Cor_ScanDesc scan(rel, &tup);

    Cor_Tuple *tuple = scan.next_tuple();

    if (scan.no_match()) {
        fprintf(stderr, "No match from arity\n");
        return(0);
    }

    if (!is_int((*tuple)[2])) {
        fprintf(stderr, "Non-interger answer from arity\n");
        return(0);
    }

    return(make_int((*tuple)[2]));
}

//**************************************************************************

int RegExScan(Tcl_Interp *interp, char *relname, char *pattern )
{
    Cor_Relation *arel;
    FILE *fp;
    char file[64];
    Cor_ScanDesc *scan;

    strcpy(file,"/tmp/__explain_pattern.F");

    if ((fp = fopen(file, "w")) == NULL){
        Tcl_AppendResult(interp,"coral: ex_open: cannot open file ",file,0);
        return(TCL_ERROR);
    }

    fprintf(fp,"explain__foo(%s).\n", pattern);
    fclose(fp);

    Cor_Tuple *tuple;


    

  // To handle CORAL code
  temp__inits();
  extern Cor_ExecutionList *temp__15;
  temp__15->execute();
  Cor_processInputStack();

#line 102 "Coral_Utils.S"



    unlink(file);

    Cor_Relation *foo_rel = find_relation("explain__foo", 1);
    Cor_ScanDesc foo_scan(foo_rel);
    Cor_Tuple *foo_t = foo_scan.next_tuple();
    if (foo_scan.no_match()) {
        Tcl_AppendResult(interp,"No value in explain__foo relation!",0);
        return(TCL_ERROR);
    }

    int max_vars = (*foo_t)[0].max_vars();
    Cor_CArg *carg = new Cor_CArg((*foo_t)[0]);
    Cor_Tuple stup(make_arglist_d(4,make_arg(relname), carg,
            make_var("X1",max_vars), make_var("X2",max_vars+1)));

    foo_t->do_delete();

    Cor_Relation* rel = find_relation("instances",4);   // a loaded func

    scan = new Cor_ScanDesc(rel, &stup);

    Tcl_AppendResult(interp,create_entry("scan",(void *) scan),0);
    return(TCL_OK);
}

//**************************************************************************

int EmptyRel(Tcl_Interp *interp, char *relname, char *str_arity )
{
    Cor_Relation *rel;
    int arity;

   if (Tcl_GetInt(interp,str_arity,&arity) != TCL_OK)
      return(TCL_ERROR);

        /*  If relation does not yet exist this is a NOP  */
    if ((rel = find_relation(relname,arity)) == NULL) {
        return(TCL_OK);
    }

    rel->empty_relation();

    return(TCL_OK);
}

//**************************************************************************

int DumpRel(Tcl_Interp *interp, char *dest_rel, char *src_rel,
                                char *str_arity )
{
    Cor_Relation *dstrel, *srcrel;
    Cor_ScanDesc *scan;
    Cor_Tuple *tuple;
    int arity;

   if (Tcl_GetInt(interp,str_arity,&arity) != TCL_OK)
      return(TCL_ERROR);

        /*    If source relation does not exist this is a NOP */
    if ((srcrel = find_relation(src_rel,arity)) == NULL) {
        return(TCL_OK);
    }

    if ((dstrel = find_relation(dest_rel,arity)) == NULL) {
        dstrel = make_rel(dest_rel,arity);
    }

    scan = new Cor_ScanDesc(srcrel);

    for (tuple = scan->next_tuple(); !(scan->no_match());
                                        tuple = scan->next_tuple()) {

        dstrel->tuple_insert(tuple);
    } 

   return(TCL_OK);
}

//**************************************************************************

static Cor_ExecutionList *temp__15;
static void temp__16(Cor_ExecutionList *exlist)
{
  // initialization code for exlist
  exlist->initialize(5, 0, NULL);
  Cor_ParserStruct *pstruct, *sv_pstruct;
  sv_pstruct = Cor_parserStruct;
    // call parse on Explain.P
  for(int i=0;;i++) {
    pstruct = new Cor_ParserStruct();
    Cor_parserStruct = pstruct;
    Cor_parseStack->parse(cerr_strm,1);
    if (Cor_exEnv->c_module_separator) break;
      // save Cor_ParserStruct in exlist
    exlist->add(pstruct);
  }
    // Restore the saved Cor_ParserStruct
  Cor_parserStruct = sv_pstruct;
  Cor_exEnv->c_module_separator = 0;
}

static void temp__11()
{
  FILE *fp = fopen("Explain.P", "w");

  fprintf(fp, "c_module.\n");
  fprintf(fp, "%s\n", "consult(\"/tmp/__explain_pattern.F\").\n");
  fprintf(fp, "end_c_module.\n\n");
  fclose(fp);
}
static void temp__12()
{
  temp__11();
  Cor_consultFile("Explain.P", "Explain.P");
  unlink("Explain.P");
  temp__16(temp__15);
}
static void _CORAL_dummytemp__13()
{
   Cor_BuiltinUserTupleRelation *temp__14;
}

static void temp__inits() {
    if (!temp__15) {
      temp__15 = new Cor_ExecutionList();
      temp__12();
    }
}

static void temp__deletes() {
  delete temp__15;
}

