
//**************************************************************************
//    User.h
//
//    The User Class - Contains all the information about a user and
//    their current envirornment.
//
//**************************************************************************

#ifndef _User_H_
#define _User_H_

#include "CoralStream.h"
#include "DatabaseStruct.h"
#include "ExecutionEnv.h"
          
//**************************************************************************

                                // The default number of answers to
                                // return before suspending
#define  DEFLT_ANSWRS_PER_QRY     20

class Cor_Collector;

//**************************************************************************

class Cor_User {

friend class Cor_Connection;

public:
  char   login_name[9];        // The login name of the user
  char   password[9];          // Their password (clear text)

  int    user_id;              // A numerical id  (this session only)

  Cor_ExecutionEnv    Cor_exEnv;   // The execution environrment for this user

  Cor_DatabaseStruct *Cor_CurDB;   // The current database of this user

  int      num_answers;        // The number of answers to return before
                               // suspending a query.

  unsigned int  qid;           // The current query id to use.

  Cor_Collector   *collector;  // Our collector (if any)

  CoralStream     *explain_strm;   // The connection back to user's explain

  Cor_User(CoralStream *in, CoralStream *out, CoralStream *err);
 ~Cor_User();

    // Tell who you are
  void whoami(CoralStream *strm);

    // Set flag(s) to indicate a yield should be performed at the end of
    // this command
  void yield();
};

//**************************************************************************

#endif  // _User_H_
