//***********************************
//  Partition.h
//
// Ravi Murthy
//***********************************

#ifdef    WITH_PERSISTENCE
#ifndef _Partition_H_
#define _Partition_H_

#include "Plan.h"
#include "JoinAttrs.h"

class Cor_Partition {
  public:
    Cor_Partition(int num_partition);
   ~Cor_Partition();

    // This function forms the partitions of the specified relation
    // on the specified join attributes. The partitions are written
    // out as temporary exodus relations.
    int FormPartitions(Cor_TupleIterator* it, Cor_JoinAttrs *attr);

    // This function returns an iterator over the relation corresponding
    // to the i th partition.
    Cor_TupleIterator  *getIterator(int part_num,
            Cor_ArgList& args, Cor_BindEnv *env);

  private:
    int         num_part;                 // Number of partitions. 
    Cor_PersistentRel  **parts;           // Temporary exodus relations
};

// *************************************************************************
#endif
#endif // WITH_PERSISTENCE
