// *************************************************************************
//    AggSelInfo.h
// *************************************************************************

#ifndef _AggSelInfo_H_
#define _AggSelInfo_H_

#include "ArgList.h"
#include "BindEnv.h"
#include "Debug.h"

    // Aggregate selectors arity is based only on its type.
#define    AGG_SELECTOR_ARITY        (5)

#define    AGG_SELECTOR_ITER_ARITY   (3)

// *************************************************************************

enum AggSelType {
    AggSel_Regular=0,      // Simple Aggregate Selection.
    AggSel_PerIter,        // Select only at the end of an iteration.
    AggSel_MultAnswers,    // Possible multiple answers (per grouping).
};

// *************************************************************************

class Cor_AggSelInfo {

  public:

    Cor_ArgList      *arglist;      // Arglist that covers literal
    Cor_ArgList      *groupbylist;  // Arglist with groupby vars common with
                                    // "arglist", and other vars distinct.
                                    // (Used for indexing)

    CArgKind          agg_kind;
    AggSelType        agg_type;     // For user-defined agg-sel

    Cor_CArg         *op_arg;       // A dup of the grouping arg.

    Cor_ArgList      *agg_val;      // Aggregated args of arglist
    Cor_ArgList      *gb_agg_val;   // Aggregated args of groupbylist

    Cor_Relation     *rel;          // For user-defined agg sel only.

    int               var_count;
    int               indexnum;     // Used to avoid repeated checks for what
                                    // index to use

    Cor_BindEnv      *bindenv;      // So it can be reused.

    Cor_AggSelInfo   *next;

    Cor_AggSelInfo();
   ~Cor_AggSelInfo();
};

// *************************************************************************

#endif _AggSelInfo_H_
