// *************************************************************************
//    RelationList.h
// *************************************************************************

#ifndef _RelationList_H_
#define _RelationList_H_

#include "StorageRelation.h"
#include "Debug.h"

// *************************************************************************

class Cor_RelationLink {

  public:
    Cor_RelationLink    *next;
    Cor_StorageRelation *reln;

    Cor_RelationLink(Cor_StorageRelation *r, Cor_RelationLink *n = NULL) {
        reln = r;
        next = n;
    }
};

// *************************************************************************

class Cor_RelationList {

  public:
    Cor_RelationLink *reln_chain;    // head of list of (Linked) Relations
    Cor_RelationLink *reln_lastptr;  // points to last RelationLink (delta new)

    Cor_RelationList() {
        reln_chain = NULL;
        reln_lastptr = NULL;
    }

   ~Cor_RelationList() {
    // SPF - pipe3L already deletes this
    // delete reln_chain;
    }

    void append_relation(Cor_StorageRelation *_rel);
    void append(Cor_RelationLink *rell);
    
    inline int insert_tuple(Cor_Tuple *tuple)
    {
  //    ASSERT((reln_lastptr != NULL) && (reln_lastptr->reln != NULL));
        return(reln_lastptr->reln->insert_tuple(tuple));
    }
};

// *************************************************************************

#endif _RelationList_H_
