// *************************************************************************
//    QFMaterializedModuleData.h
// *************************************************************************

#ifndef _QFMaterializedModuleData_H_
#define _QFMaterializedModuleData_H_

#include "QFModuleData.h"
#include "Table.h"
#include "RuleInfoArray.h"
#include "ParserStruct.h"
#include "Scc.h"
#include "Predicate.h"
#include "TupleIterator.h"
#include "SccInfo.h"

// *************************************************************************

class Cor_QFMaterializedModuleData : public Cor_QFModuleData {

  public:
    int           numSccs;
    Cor_SccInfo **sccArray;            // Array of Sccs to evaluate in order

    Cor_QFMaterializedModuleData(Cor_Table *table, Cor_RuleInfoArray *rArray,
        Cor_ParserStruct*);
   ~Cor_QFMaterializedModuleData();

    void AddScc(Cor_Scc *scc, Cor_Predicate *ext_magicpred);
    virtual void Solve(Cor_Table *F, Cor_TupleIterator *iterator = NULL);
    void clean_cache();
    virtual ModuleKind kindof()    { return COR_MATERIALIZED; };
    void print(ostream *fd, int print_preds = 1, 
         int print_text = 1, int print_snrules = 1);
};

// *************************************************************************

#endif _QFMaterializedModuleData_H_
