// *************************************************************************
//    SMUtil.C
// *************************************************************************

#ifdef WITH_PERSISTENCE


#include "Globals.h"
#include "CoralError.h"
#include "SMUtil.h"
#include "sm_client.h"
#include "Config.h"
#include "Schema.h"
#include "IndexStruct.h"
#include "BPlusTreeIndex.h"
#include "FileDescStruct.h"
#include "BufferGroup.h"
#include "Transaction.h"
#include "Catalog.h"
#include "StorageManager.h"
#include "Debug.h"


// *************************************************************************
void commitTrans()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (SM_initialized) SM.commitTrans();
}

// *************************************************************************
void abortTrans()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (SM_initialized) SM.abortTrans();
}

// *************************************************************************
void shutdown_server()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (SM_initialized) {
        SM.shutdown();
    }
}

// *************************************************************************
void sm_init()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    SM.init();
}

// *************************************************************************
//    Check Storage Manager return codes

int ErrorCheck (int e, char *routine)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (e < 0) {
        if (verboseError) {
            if (!SM_initialized) {
                *(Cor_exEnv->err_strm) << 
                    "Warning: Cannot connect to EXODUS storage manager\n";
            }
            *(Cor_exEnv->err_strm) << "Got a Storage Manager error from "
                    << routine << endl;
            *(Cor_exEnv->err_strm) << "Error = " <<  m_Error(m_errno)
                << endl << flush;
            // if (SM_initialized)
            //SM.shutdown(); -- Not for simple errors!
        }
        return 1;
    }
    return(0);
}

// *************************************************************************

#endif WITH_PERSISTENCE
