// *************************************************************************
//    BuiltinSymbols.C
// *************************************************************************

// *************************************************************************

#include "Debug.h"
#include "CArg.h"
#include "Globals.h"

#define Keyword(x,s)     Cor_CArg *x;
#undef _BuiltinSymbols_H_
#include "BuiltinSymbols.h"

Cor_CArg  *Cor_builtin_ops[NUMBER_OF_BUILTINS];
int        Cor_Builtin_Arith_Start;
int        Cor_Builtin_Convertible_Start;

static void setup_builtins();

// *************************************************************************
void Cor_init_builtin_symbols()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif

#define Keyword(x,s)     x = new Cor_CArg(s);
#undef _BuiltinSymbols_H_
#include "BuiltinSymbols.h"

    setup_builtins();
}

// *************************************************************************
void Cor_free_builtin_symbols()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif

#define Keyword(x,s)     delete x;
#undef _BuiltinSymbols_H_
#include "BuiltinSymbols.h"

}

// *************************************************************************
static void setup_builtins() {

    Cor_Builtin_Arith_Start = 13;
    Cor_Builtin_Convertible_Start = 17;

    int j=0;

#define   BUILTIN_INSERT(X)  \
    Cor_builtin_ops[j++] = (X);

    // Aggregation operators: These must be FIRST, and in the same ORDER
    // as the Grouping section in the enum CArgKind (defined in CArg.h).
    BUILTIN_INSERT(Cor_SumOpSymbol);       // SUM_GRPING_ARG
    BUILTIN_INSERT(Cor_ProdOpSymbol);      // PROD_GRPING_ARG
    BUILTIN_INSERT(Cor_CountOpSymbol);     // CNT_GRPING_ARG
    BUILTIN_INSERT(Cor_AvgOpSymbol);       // AVG_GRPING_ARG
    BUILTIN_INSERT(Cor_StdDevOpSymbol);    // STDDEV_GRPING_ARG

    BUILTIN_INSERT(Cor_SDstOpSymbol);      // SUM_DGRPING_ARG
    BUILTIN_INSERT(Cor_PDstOpSymbol);      // PROD_DGRPING_ARG
    BUILTIN_INSERT(Cor_CDstOpSymbol);      // CNT_DGRPING_ARG
    BUILTIN_INSERT(Cor_ADstOpSymbol);      // AVG_DGRPING_ARG

    BUILTIN_INSERT(Cor_MinOpSymbol);       // MIN_GRPING_ARG
    BUILTIN_INSERT(Cor_MaxOpSymbol);       // MAX_GRPING_ARG

    BUILTIN_INSERT(Cor_DstOpSymbol);       // SET_GRPING_ARG
    BUILTIN_INSERT(Cor_AnyOpSymbol);       // ANY_GRPING_ARG

    // Normal (not aggregation) operators:
    // Builtin_Arith_Start = 13 
    BUILTIN_INSERT(Cor_LssOpSymbol);
    BUILTIN_INSERT(Cor_GrtOpSymbol);
    BUILTIN_INSERT(Cor_LeqOpSymbol);
    BUILTIN_INSERT(Cor_GeqOpSymbol);

    // Builtin_Convertible_Start = 17
    BUILTIN_INSERT(Cor_AddOpSymbol);
    BUILTIN_INSERT(Cor_SubOpSymbol);
    BUILTIN_INSERT(Cor_MulOpSymbol);
    BUILTIN_INSERT(Cor_DivOpSymbol);
    BUILTIN_INSERT(Cor_IDivOpSymbol);

    BUILTIN_INSERT(Cor_LShiftOpSymbol);
    BUILTIN_INSERT(Cor_RShiftOpSymbol);
    BUILTIN_INSERT(Cor_BitxorOpSymbol);
    BUILTIN_INSERT(Cor_BitandOpSymbol);
    BUILTIN_INSERT(Cor_BitorOpSymbol);
    BUILTIN_INSERT(Cor_BitnotOpSymbol);
    BUILTIN_INSERT(Cor_ModOpSymbol);

    Cor_builtin_ops[j] = NULL;

#undef   BUILTIN_INSERT
}

// *************************************************************************
