// *************************************************************************
//    IO_Solvers.h
// *************************************************************************

#ifndef _IO_Solvers_H_
#define _IO_Solvers_H_

// *************************************************************************

#include "CoralError.h"

class Cor_BuiltinRelation;
class Cor_TupleIterator;
class Cor_BindEnv;
class Cor_Tuple;

// *************************************************************************

Cor_BindEnv *Cor_EmptyPrintSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_TuplePrintSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_BindingsPrintSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_LiteralPrintSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_PrintSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_PrintfSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_ConsultSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_ReadTable(char *infile,Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_WriteTableSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_pipeInSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_pipeOutSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_ShellSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);

// *************************************************************************

#endif _IO_Solvers_H_
